// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package com.springsource.petclinic.web;

import com.springsource.petclinic.domain.Owner;
import com.springsource.petclinic.domain.Pet;
import java.io.UnsupportedEncodingException;
import java.lang.Integer;
import java.lang.Long;
import java.lang.Object;
import java.lang.String;
import java.util.Collection;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.joda.time.format.DateTimeFormat;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;

privileged aspect OwnerController_Roo_Controller {
    
    @RequestMapping(method = RequestMethod.POST)
    public String OwnerController.create(@Valid Owner owner, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("owner", owner);
            addDateTimeFormatPatterns(model);
            return "owners/create";
        }
        owner.persist();
        return "redirect:/owners/" + encodeUrlPathSegment(owner.getId().toString(), request);
    }
    
    @RequestMapping(params = "form", method = RequestMethod.GET)
    public String OwnerController.createForm(Model model) {
        model.addAttribute("owner", new Owner());
        addDateTimeFormatPatterns(model);
        return "owners/create";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public String OwnerController.show(@PathVariable("id") Long id, Model model) {
        addDateTimeFormatPatterns(model);
        model.addAttribute("owner", Owner.findOwner(id));
        model.addAttribute("itemId", id);
        return "owners/show";
    }
    
    @RequestMapping(method = RequestMethod.GET)
    public String OwnerController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            model.addAttribute("owners", Owner.findOwnerEntries(page == null ? 0 : (page.intValue() - 1) * sizeNo, sizeNo));
            float nrOfPages = (float) Owner.countOwners() / sizeNo;
            model.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            model.addAttribute("owners", Owner.findAllOwners());
        }
        addDateTimeFormatPatterns(model);
        return "owners/list";
    }
    
    @RequestMapping(method = RequestMethod.PUT)
    public String OwnerController.update(@Valid Owner owner, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("owner", owner);
            addDateTimeFormatPatterns(model);
            return "owners/update";
        }
        owner.merge();
        return "redirect:/owners/" + encodeUrlPathSegment(owner.getId().toString(), request);
    }
    
    @RequestMapping(value = "/{id}", params = "form", method = RequestMethod.GET)
    public String OwnerController.updateForm(@PathVariable("id") Long id, Model model) {
        model.addAttribute("owner", Owner.findOwner(id));
        addDateTimeFormatPatterns(model);
        return "owners/update";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public String OwnerController.delete(@PathVariable("id") Long id, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        Owner.findOwner(id).remove();
        model.addAttribute("page", (page == null) ? "1" : page.toString());
        model.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/owners?page=" + ((page == null) ? "1" : page.toString()) + "&size=" + ((size == null) ? "10" : size.toString());
    }
    
    @ModelAttribute("pets")
    public Collection<Pet> OwnerController.populatePets() {
        return Pet.findAllPets();
    }
    
    void OwnerController.addDateTimeFormatPatterns(Model model) {
        model.addAttribute("owner_birthday_date_format", DateTimeFormat.patternForStyle("S-", LocaleContextHolder.getLocale()));
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET, headers = "Accept=application/json")
    @ResponseBody
    public Object OwnerController.showJson(@PathVariable("id") Long id) {
        Owner owner = Owner.findOwner(id);
        if (owner == null) {
            return new ResponseEntity<String>(HttpStatus.NOT_FOUND);
        }
        return owner.toJson();
    }
    
    @RequestMapping(value = "/jsonArray", method = RequestMethod.POST, headers = "Accept=application/json")
    public ResponseEntity<String> OwnerController.createFromJsonArray(@RequestBody String json) {
        for (Owner owner: Owner.fromJsonArrayToOwners(json)) {
            owner.persist();
        }
        return new ResponseEntity<String>(HttpStatus.CREATED);
    }
    
    @RequestMapping(value = "/jsonArray", method = RequestMethod.PUT, headers = "Accept=application/json")
    public ResponseEntity<String> OwnerController.updateFromJsonArray(@RequestBody String json) {
        for (Owner owner: Owner.fromJsonArrayToOwners(json)) {
            if (owner.merge() == null) {
                return new ResponseEntity<String>(HttpStatus.NOT_FOUND);
            }
        }
        return new ResponseEntity<String>(HttpStatus.OK);
    }
    
    String OwnerController.encodeUrlPathSegment(String pathSegment, HttpServletRequest request) {
        String enc = request.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        }
        catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
