// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package com.springsource.petclinic.web;

import com.springsource.petclinic.domain.Owner;
import com.springsource.petclinic.domain.Pet;
import com.springsource.petclinic.reference.PetType;
import java.io.UnsupportedEncodingException;
import java.lang.Float;
import java.lang.Integer;
import java.lang.Long;
import java.lang.Object;
import java.lang.String;
import java.util.Arrays;
import java.util.Collection;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;

privileged aspect PetController_Roo_Controller {
    
    @RequestMapping(method = RequestMethod.POST)
    public String PetController.create(@Valid Pet pet, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("pet", pet);
            return "pets/create";
        }
        pet.persist();
        return "redirect:/pets/" + encodeUrlPathSegment(pet.getId().toString(), request);
    }
    
    @RequestMapping(params = "form", method = RequestMethod.GET)
    public String PetController.createForm(Model model) {
        model.addAttribute("pet", new Pet());
        return "pets/create";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public String PetController.show(@PathVariable("id") Long id, Model model) {
        model.addAttribute("pet", Pet.findPet(id));
        model.addAttribute("itemId", id);
        return "pets/show";
    }
    
    @RequestMapping(method = RequestMethod.GET)
    public String PetController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            model.addAttribute("pets", Pet.findPetEntries(page == null ? 0 : (page.intValue() - 1) * sizeNo, sizeNo));
            float nrOfPages = (float) Pet.countPets() / sizeNo;
            model.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            model.addAttribute("pets", Pet.findAllPets());
        }
        return "pets/list";
    }
    
    @RequestMapping(method = RequestMethod.PUT)
    public String PetController.update(@Valid Pet pet, BindingResult result, Model model, HttpServletRequest request) {
        if (result.hasErrors()) {
            model.addAttribute("pet", pet);
            return "pets/update";
        }
        pet.merge();
        return "redirect:/pets/" + encodeUrlPathSegment(pet.getId().toString(), request);
    }
    
    @RequestMapping(value = "/{id}", params = "form", method = RequestMethod.GET)
    public String PetController.updateForm(@PathVariable("id") Long id, Model model) {
        model.addAttribute("pet", Pet.findPet(id));
        return "pets/update";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public String PetController.delete(@PathVariable("id") Long id, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model model) {
        Pet.findPet(id).remove();
        model.addAttribute("page", (page == null) ? "1" : page.toString());
        model.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/pets?page=" + ((page == null) ? "1" : page.toString()) + "&size=" + ((size == null) ? "10" : size.toString());
    }
    
    @RequestMapping(params = { "find=ByNameAndWeight", "form" }, method = RequestMethod.GET)
    public String PetController.findPetsByNameAndWeightForm(Model model) {
        return "pets/findPetsByNameAndWeight";
    }
    
    @RequestMapping(params = "find=ByNameAndWeight", method = RequestMethod.GET)
    public String PetController.findPetsByNameAndWeight(@RequestParam("name") String name, @RequestParam("weight") Float weight, Model model) {
        model.addAttribute("pets", Pet.findPetsByNameAndWeight(name, weight).getResultList());
        return "pets/list";
    }
    
    @RequestMapping(params = { "find=ByOwner", "form" }, method = RequestMethod.GET)
    public String PetController.findPetsByOwnerForm(Model model) {
        model.addAttribute("owners", Owner.findAllOwners());
        return "pets/findPetsByOwner";
    }
    
    @RequestMapping(params = "find=ByOwner", method = RequestMethod.GET)
    public String PetController.findPetsByOwner(@RequestParam("owner") Owner owner, Model model) {
        model.addAttribute("pets", Pet.findPetsByOwner(owner).getResultList());
        return "pets/list";
    }
    
    @RequestMapping(params = { "find=BySendRemindersAndWeightLessThan", "form" }, method = RequestMethod.GET)
    public String PetController.findPetsBySendRemindersAndWeightLessThanForm(Model model) {
        return "pets/findPetsBySendRemindersAndWeightLessThan";
    }
    
    @RequestMapping(params = "find=BySendRemindersAndWeightLessThan", method = RequestMethod.GET)
    public String PetController.findPetsBySendRemindersAndWeightLessThan(@RequestParam(value = "sendReminders", required = false) boolean sendReminders, @RequestParam("weight") Float weight, Model model) {
        model.addAttribute("pets", Pet.findPetsBySendRemindersAndWeightLessThan(sendReminders, weight).getResultList());
        return "pets/list";
    }
    
    @RequestMapping(params = { "find=ByTypeAndNameLike", "form" }, method = RequestMethod.GET)
    public String PetController.findPetsByTypeAndNameLikeForm(Model model) {
        model.addAttribute("pettypes", java.util.Arrays.asList(PetType.class.getEnumConstants()));
        return "pets/findPetsByTypeAndNameLike";
    }
    
    @RequestMapping(params = "find=ByTypeAndNameLike", method = RequestMethod.GET)
    public String PetController.findPetsByTypeAndNameLike(@RequestParam("type") PetType type, @RequestParam("name") String name, Model model) {
        model.addAttribute("pets", Pet.findPetsByTypeAndNameLike(type, name).getResultList());
        return "pets/list";
    }
    
    @ModelAttribute("owners")
    public Collection<Owner> PetController.populateOwners() {
        return Owner.findAllOwners();
    }
    
    @ModelAttribute("pettypes")
    public Collection<PetType> PetController.populatePetTypes() {
        return Arrays.asList(PetType.class.getEnumConstants());
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET, headers = "Accept=application/json")
    @ResponseBody
    public Object PetController.showJson(@PathVariable("id") Long id) {
        Pet pet = Pet.findPet(id);
        if (pet == null) {
            return new ResponseEntity<String>(HttpStatus.NOT_FOUND);
        }
        return pet.toJson();
    }
    
    @RequestMapping(value = "/jsonArray", method = RequestMethod.POST, headers = "Accept=application/json")
    public ResponseEntity<String> PetController.createFromJsonArray(@RequestBody String json) {
        for (Pet pet: Pet.fromJsonArrayToPets(json)) {
            pet.persist();
        }
        return new ResponseEntity<String>(HttpStatus.CREATED);
    }
    
    @RequestMapping(value = "/jsonArray", method = RequestMethod.PUT, headers = "Accept=application/json")
    public ResponseEntity<String> PetController.updateFromJsonArray(@RequestBody String json) {
        for (Pet pet: Pet.fromJsonArrayToPets(json)) {
            if (pet.merge() == null) {
                return new ResponseEntity<String>(HttpStatus.NOT_FOUND);
            }
        }
        return new ResponseEntity<String>(HttpStatus.OK);
    }
    
    @RequestMapping(params = "find=ByNameAndWeight", method = RequestMethod.GET, headers = "Accept=application/json")
    public String PetController.jsonFindPetsByNameAndWeight(@RequestParam("name") String name, @RequestParam("weight") Float weight, Model model) {
        return Pet.toJsonArray(Pet.findPetsByNameAndWeight(name, weight).getResultList());
    }
    
    @RequestMapping(params = "find=ByOwner", method = RequestMethod.GET, headers = "Accept=application/json")
    public String PetController.jsonFindPetsByOwner(@RequestParam("owner") Owner owner, Model model) {
        return Pet.toJsonArray(Pet.findPetsByOwner(owner).getResultList());
    }
    
    @RequestMapping(params = "find=BySendRemindersAndWeightLessThan", method = RequestMethod.GET, headers = "Accept=application/json")
    public String PetController.jsonFindPetsBySendRemindersAndWeightLessThan(@RequestParam(value = "sendReminders", required = false) boolean sendReminders, @RequestParam("weight") Float weight, Model model) {
        return Pet.toJsonArray(Pet.findPetsBySendRemindersAndWeightLessThan(sendReminders, weight).getResultList());
    }
    
    @RequestMapping(params = "find=ByTypeAndNameLike", method = RequestMethod.GET, headers = "Accept=application/json")
    public String PetController.jsonFindPetsByTypeAndNameLike(@RequestParam("type") PetType type, @RequestParam("name") String name, Model model) {
        return Pet.toJsonArray(Pet.findPetsByTypeAndNameLike(type, name).getResultList());
    }
    
    String PetController.encodeUrlPathSegment(String pathSegment, HttpServletRequest request) {
        String enc = request.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        }
        catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
